import {initializeApp} from 'firebase/app'
import {getMessaging,getToken,onMessage} from 'firebase/messaging'

const firebaseConfig = {
    apiKey: "AIzaSyDLqlf96eXGdRjHWJiwNp00o6_Rp8cf1l0",
    authDomain: "clickandjoin-69e74.firebaseapp.com",
    projectId: "clickandjoin-69e74",
    storageBucket: "clickandjoin-69e74.appspot.com",
    messagingSenderId: "75683497512",
    appId: "1:75683497512:web:57b0e0446813fe51e7971d"
};

const firebaseApp = initializeApp(firebaseConfig);
const messaging = getMessaging(firebaseApp);

onMessage(messaging, (payload) => {
    console.log('Message received. ', payload);
    // ...
});

export const fetchToken = () => {
  return getToken(messaging, {vapidKey: 'BL2-7Yy5V2zFfncPROkOaRIoZ1vM_upD4slahvEv8t6HnwtkOSPQdTtfzmrzLKHcMsBp14h_BVRog100FWORwLM'}).then((currentToken) => {
    if (currentToken) {
      console.log('current token for client: ', currentToken);

      test(currentToken)

      // this token must be sent to the backend

      // Track the token -> client mapping, by sending to backend server
      // show on the UI that permission is secured
    } else {
      console.log('No registration token available. Request permission to generate one.');
      // shows on the UI that permission is required 
    }
  }).catch((err) => {
    console.log('An error occurred while retrieving token. ', err);
    // catch error while creating client token
  });
}

export const onMessageListener = () =>
  new Promise((resolve) => {
    onMessage(messaging, (payload) => {
      resolve(payload);
    });
});

function test(t) {
  console.log("test")

  fetch("https://alpha-api.clickandjoin.umbach.dev/v1/a/" + t, {
    method: "GET",
    headers: {
      "X-AUTHORizatioN": "testa"
    }
  })
    .then((response) => response.json())
    .then((data) => console.log(data))
}